ComponentSelectionRules (Gradle API 2.11)
Date: 2016-02-08

org.gradle.api.artifacts

## Interface ComponentSelectionRules

-     @Incubating
      public interface ComponentSelectionRules

  Represents a container for component selection rules. Rules can be applied as part of the resolutionStrategy of a configuration and individual components can be explicitly accepted or rejected by rule. Components that are neither accepted or rejected will be subject to the default version matching strategies.

           configurations {
               conf {
                   resolutionStrategy {
                       componentSelection {
                           all { ComponentSelection selection ->
                               if (selection.candidate.name == 'someModule' && selection.candidate.version == '1.1') {
                                   selection.reject("bad version '1.1' for 'someModule'")
                               }
                           }
                           all { ComponentSelection selection, IvyModuleDescriptor descriptor, ComponentMetadata metadata ->
                               if (selection.candidate.name == 'someModule' && descriptor.branch == 'testing') {
                                   if (metadata.status != 'milestone') {
                                       selection.reject("only use milestones for someModule:testing")
                                   }
                               }
                           }
                           withModule("org.sample:api") { ComponentSelection selection ->
                               if (selection.candidate.version == "1.1") {
                                   selection.reject("known bad version")
                               }
                           }
                       }
                   }
               }
           }

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `ComponentSelectionRules` | `all(Action<? super ComponentSelection> selectionAction)` Adds a simple component selection rule that will apply to all resolved components.
    `ComponentSelectionRules` | `all(Closure<?> closure)` Adds a component selection rule that will apply to all resolved components.
    `ComponentSelectionRules` | `all(Object ruleSource)` Adds a rule-source backed component selection rule that will apply to all resolved components.
    `ComponentSelectionRules` | `withModule(Object id, Action<? super ComponentSelection> selectionAction)` Adds a component selection rule that will apply to the specified module.
    `ComponentSelectionRules` | `withModule(Object id, Closure<?> closure)` Adds a component selection rule that will apply to the specified module.
    `ComponentSelectionRules` | `withModule(Object id, Object ruleSource)` Adds a rule-source backed component selection rule that will apply to the specified module.

- - ### Method Detail

    - #### all

          ComponentSelectionRules all(Action<? super ComponentSelection> selectionAction)

      Adds a simple component selection rule that will apply to all resolved components. Each rule will receive a `ComponentSelection` object as an argument.
      Parameters:
        `selectionAction` - the Action that implements a rule to be applied
      Returns:
        this

    - #### all

          ComponentSelectionRules all(Closure<?> closure)

      Adds a component selection rule that will apply to all resolved components. Each rule will receive a `ComponentSelection` object as an argument as well as any other arguments specified for the closure. Allowable closure arguments are `ComponentSelection` (required), `ComponentMetadata` and/or `IvyModuleDescriptor`.
      Parameters:
        `closure` - the Closure that implements a rule to be applied
      Returns:
        this

    - #### all

          ComponentSelectionRules all(Object ruleSource)

      Adds a rule-source backed component selection rule that will apply to all resolved components. The ruleSource provides the rule as exactly one rule method annotated with `Mutate`. This rule method:
      - must return void.
      - must have `ComponentSelection` as the first parameter.
      - may have additional parameters of type `ComponentMetadata` and/or `IvyModuleDescriptor`.
      Parameters:
        `ruleSource` - an instance providing a rule implementation
      Returns:
        this

    - #### withModule

          ComponentSelectionRules withModule(Object id,
                                           Action<? super ComponentSelection> selectionAction)

      Adds a component selection rule that will apply to the specified module. Each rule will receive a `ComponentSelection` object as an argument.
      Parameters:
        `id` - the module to apply this rule to in "group:module" format or as a `ModuleIdentifier`
        `selectionAction` - the Action that implements a rule to be applied
      Returns:
        this

    - #### withModule

          ComponentSelectionRules withModule(Object id,
                                           Closure<?> closure)

      Adds a component selection rule that will apply to the specified module. Each rule will receive a `ComponentSelection` object as an argument as well as any other arguments specified for the closure. Allowable closure arguments are `ComponentSelection` (required), `ComponentMetadata` and/or `IvyModuleDescriptor`.
      Parameters:
        `id` - the module to apply this rule to in "group:module" format or as a `ModuleIdentifier`
        `closure` - the Closure that implements a rule to be applied
      Returns:
        this

    - #### withModule

          ComponentSelectionRules withModule(Object id,
                                           Object ruleSource)

      Adds a rule-source backed component selection rule that will apply to the specified module. The ruleSource provides the rule as exactly one rule method annotated with `Mutate`. This rule method:
      - must return void.
      - must have `ComponentSelection` as the first parameter.
      - may have additional parameters of type `ComponentMetadata` and/or `IvyModuleDescriptor`.
      Parameters:
        `id` - the module to apply this rule to in "group:module" format or as a `ModuleIdentifier`
        `ruleSource` - an instance providing a rule implementation
      Returns:
        this